package ij2x.plugin;

import javax.swing.Icon;
import java.awt.Component;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Shape;
import java.awt.Rectangle;
import java.awt.image.BufferedImage;
import java.util.*;
import java.beans.*;
import javax.swing.*;

/**
 * <p>Title: ColorIcon</p>
 * <p>Description: implements Icon to draw a solid "iconWidth x iconHeight" block of the
 * specified color.</p>
 * <p>Copyright: Copyright (c) </p>
 * <p>Company: dp</p>
 * @author Mahdi Rawak
 * @version 1.0
 */

  public class ColorIcon implements Icon {

  protected Color color, oldcolor;
  protected int iconWidth =9;
  protected int iconHeight=9;
  protected int iconWidth1 =0;
  protected int iconHeight1=0;
  protected Shape icon, polygon;
  protected Vector shapeEventListeners = new Vector();
  protected Graphics2D offScrGc;
  protected int x, y;
  private PropertyChangeSupport pcs;
  protected BufferedImage bimage;
  protected boolean isPolygon = false, modal=false;;
  /**
   * This public class implements Icon to draw a solid "iconWidth x iconHeight" block of the
   * specified color.  Most icons are instances of ImageIcon, but since
   * we're only using solid colors here, it is easier to implement this
   * custom Icon type
   **/

  /** @param color  is selected Icon Color */

  public ColorIcon(Color color,int iconWidth,int iconHeight,int iconWidth1,int iconHeight1, boolean modal) {
    try {
      this.color = color;
      this.iconWidth=iconWidth;
      this.iconHeight=iconHeight;
      this.iconWidth1=iconWidth1;
      this.iconHeight1=iconHeight1;
      this.modal=modal;
      isPolygon=true;
      pcs = new PropertyChangeSupport(this);
    }
    catch (Exception ex) {

    }
  }
  /** @param color  is selected Icon Color */

  public ColorIcon(Color color,int iconWidth,int iconHeight) {
    try {
      this.color = color;
      this.iconWidth=iconWidth;
      this.iconHeight=iconHeight;
      isPolygon = false;
      pcs = new PropertyChangeSupport(this);
    }
    catch (Exception ex) {

    }
  }
  /** @param color  is selected Icon Color */

  public ColorIcon(Color color) {
try {
      this.color = color;
      pcs = new PropertyChangeSupport(this);
    }
catch (Exception ex) {

    }
  }

  public ColorIcon() {
          this(Color.white, 9, 9);
          pcs = new PropertyChangeSupport(this);
  }

  public void paintIcon(Component c, Graphics g, int x, int y) {
    this.x=x;
    this.y=y;
    offScrGc = (Graphics2D) g;
    offScrGc.setColor(getColor());
    if(!isPolygon){
    icon = new Rectangle(x, y, iconWidth, iconHeight);
    offScrGc.fill(icon);}
    else{
        offScrGc.setColor(Color.black);
        offScrGc.draw3DRect(x-2, y-2, iconWidth+3, iconHeight+3, true);
        offScrGc.setColor(getColor());
        offScrGc.fill3DRect(x, y, iconWidth, iconHeight, modal);
        offScrGc.setColor(Color.white);
        offScrGc.fillRect(x + iconWidth-iconWidth1-1, iconHeight-iconHeight1+3, iconWidth1+2, iconHeight1);
        offScrGc.setColor(Color.black);

        offScrGc.drawRect(x + iconWidth-iconWidth1+1, iconHeight-iconHeight1+5, iconWidth1-2, 1);
        offScrGc.drawRect(x + iconWidth-iconWidth1+2, iconHeight-iconHeight1+6, iconWidth1-4, 1);
        offScrGc.drawRect(x + iconWidth-iconWidth1+3, iconHeight-iconHeight1+7, iconWidth1-6, 1);
        offScrGc.drawRect(x + iconWidth-iconWidth1+4, iconHeight-iconHeight1+8, iconWidth1-8, 1);
    }
  }
  public Color getColor() {
          return color;
  }
  public void setColor(Color color) {
    this.color = color;
    pcs.firePropertyChange("iconColor", oldcolor, color);
    oldcolor=color;
  }
  public Graphics2D getIconGC() {
          return offScrGc;
  }
  public int getIconWidth() {
    return iconWidth;
  }
  public int getIconHeight() {
    return iconHeight;
  }

 public void updateShape(){
   //fireShapeEvent();
 }
 public void addPropertyChangeListener(PropertyChangeListener p){
    pcs.addPropertyChangeListener(p);
 }

  public void removePropertyChangeListener(PropertyChangeListener p){
     pcs.removePropertyChangeListener(p);
 }

}
